#
# Exportimport NodeAdapter tests
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.UnicodeLexicon.tests import UnicodeLexiconTestCase
from Products.GenericSetup.testing import NodeAdapterTestCase
from Products.Five import zcml


_UNICODELEXICON_XML = """\
<object name="unicode_lexicon" meta_type="ZCTextIndex Unicode Lexicon">
 <element name="HTML aware splitter" group="Word Splitter"/>
 <element name="Case normalizer" group="Case Normalizer"/>
</object>
"""


class UnicodeLexiconNodeAdapterTests(NodeAdapterTestCase):

    def _getTargetClass(self):
        from Products.UnicodeLexicon.exportimport \
                    import UnicodeLexiconNodeAdapter
        return UnicodeLexiconNodeAdapter

    def _populate(self, obj):
        from Products.UnicodeLexicon.UnicodeSplitter import UnicodeHTMLWordSplitter
        from Products.UnicodeLexicon.UnicodeSplitter import UnicodeCaseNormalizer
        obj._pipeline = (UnicodeHTMLWordSplitter(), UnicodeCaseNormalizer())

    def setUp(self):
        import Products.GenericSetup
        import Products.UnicodeLexicon
        from Products.UnicodeLexicon.UnicodeLexicon import UnicodeLexicon

        NodeAdapterTestCase.setUp(self)
        zcml.load_config('meta.zcml', Products.GenericSetup)
        zcml.load_config('configure.zcml', Products.UnicodeLexicon)

        self._obj = UnicodeLexicon('unicode_lexicon')
        self._XML = _UNICODELEXICON_XML

    def tearDown(self):
        # XXX: Do *not* tear down the CA here as this interacts
        # badly with other test modules, particularly testSetup.
        pass


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(UnicodeLexiconNodeAdapterTests))
    return suite

if __name__ == '__main__':
    framework()

